/***
*
*    Copyright (c) 1996-2002, Valve LLC. All rights reserved.
*
*    This product contains software technology licensed from Id
*    Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc.
*    All Rights Reserved.
*
*    Compiling or running this code may violate patents in certain countries.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/

#ifndef CBASEDELAY__H
#define CBASEDELAY__H

typedef struct CBaseDelay_t CBaseDelay;
typedef struct CBaseDelay_s
{
	_vt_CBaseDelay*		vtable;
	#include "./offsets_cbasedelay.h"

} CBaseDelay_t;

typedef struct CTestEffect_t CTestEffect;
typedef struct CTestEffect_s
{
	_vt_CTestEffect*		vtable;
	#include "./offsets_cbasedelay.h"

	int		m_iLoop;
	int		m_iBeam;
	CBeam*		m_pBeam[24];
	float		m_flBeamTime[24];
	float		m_flStartTime;

} CTestEffect_t;

typedef struct CEnvFunnel_t CEnvFunnel;
typedef struct CEnvFunnel_s
{
	_vt_CEnvFunnel*		vtable;
	#include "./offsets_cbasedelay.h"
	
	int		m_iSprite;	// Don't save, precache // 36

} CEnvFunnel_t;

typedef struct CBreakable_t CBreakable;
typedef struct CBreakable_s
{
	_vt_CBreakable*		vtable;
	#include "./offsets_cbasedelay.h"
	
	Materials	m_Material;				// 36
	Explosions	m_Explosion;				// 37
	int		m_idShard;				// 38
	float		m_angle;				// 39
	int		m_iszGibModel;				// 40
	int		m_iszSpawnObject;			// 42

} CBreakable_t;

typedef struct CAutoTrigger_t CAutoTrigger;
typedef struct CAutoTrigger_s
{
	_vt_CAutoTrigger*		vtable;
	#include "./offsets_cbasedelay.h"

	int		m_globalstate;				// 36
	USE_TYPE	triggerType;				// 37

} CAutoTrigger_t;

typedef struct CTriggerRelay_t CTriggerRelay;
typedef struct CTriggerRelay_s
{
	_vt_CTriggerRelay*		vtable;
	#include "./offsets_cbasedelay.h"

	USE_TYPE	triggerType;				// 36

} CTriggerRelay_t;

typedef struct CTriggerChangeTarget_t CTriggerChangeTarget;
typedef struct CTriggerChangeTarget_s
{
	_vt_CTriggerChangeTarget*		vtable;
	#include "./offsets_cbasedelay.h"

	int		m_iszNewTarget; 			// 36

} CTriggerChangeTarget_t;

typedef struct CTriggerCamera_t CTriggerCamera;
typedef struct CTriggerCamera_s
{
		_vt_CTriggerCamera*		vtable;	
	#include "./offsets_cbasedelay.h"
	
	_EHANDLE	m_hPlayer;				// 36
//	int m_hPlayer_dummy;
	_EHANDLE	m_hTarget;				// 38
//	int m_hTarget_dummy;
	CBaseEntity*	m_pentPath;				// 40
	int		m_sPath;				// 41
	float		m_flWait;				// 42
	float		m_flReturnTime;				// 43
	float		m_flStopTime;				// 44
	float		m_moveDistance;				// 45
	float		m_targetSpeed;				// 46
	float		m_initialSpeed;				// 47
	float		m_acceleration;				// 48
	float		m_deceleration;				// 49
	int		m_state;				// 50
	
} CTriggerCamera_t;

typedef struct CEnvBeverage_t CEnvBeverage;
typedef struct CEnvBeverage_s
{
	_vt_CEnvBeverage*		vtable;
	#include "./offsets_cbasedelay.h"

} CEnvBeverage_t;

typedef struct CFireAndDie_t CFireAndDie;
typedef struct CFireAndDie_s
{
	_vt_CFireAndDie*		vtable;
	#include "./offsets_cbasedelay.h"

} CFireAndDie_t;

#endif

