/***
*
*    Copyright (c) 1996-2002, Valve LLC. All rights reserved.
*
*    This product contains software technology licensed from Id
*    Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc.
*    All Rights Reserved.
*
*    Compiling or running this code may violate patents in certain countries.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/

#ifndef CBASEMONSTER__H
#define CBASEMONSTER__H

typedef struct CBaseMonster_t CBaseMonster;
typedef struct CBaseMonster_s
{

	_vt_CBaseMonster*		vtable;
	#include "./offsets_cbasemonster.h"
	
} CBaseMonster_t;

typedef struct CBasePlayer_t CBasePlayer;
typedef struct CBasePlayer_s
{

	_vt_CBasePlayer*		vtable;
	#include "./offsets_cbasemonster.h"

	int						random_seed;										// 96   // See that is shared between client & server for shared weapons code

	int _dummy_1684;

	EHANDLE				m_hSpectatedTarget;		//??					// 98
//	int						m_hSpectatedTarget_dummy;
	float						m_flNextSpecButtonTime;						// 100
	int						m_iSpectatedPlayerWeaponId;				// 101
	BOOL					m_fHasSpectatedPlayerC4;					// 102
	BOOL					m_fHasSpectatedPlayerDefuseKit;			// 103
	int						m_iObserverMode;									// 104
	float						m_flAnimationTimeDummy;					// 105
	
	int _dummy_81318;	// m_flAnimationTimeDummy double ??
	
	BOOL					m_fHasTakenHighDamage;						// 107		// Last damage > 60 ?
	float						m_flPainShock;										// 108
	int						m_iLastZoom;//?									// 109
	BOOL					m_fResumeZoom;									// 110
	float						m_flEjectBrass;										// 111
	int						m_iKevlarType;										// 112
	BOOL					m_fHasSurvivedLastRound;						// 113
	int						m_iTeam;												// 114
	int						m_iAccount;											// 115
	BOOL					m_fHasPrimary;										// 116
	
	int		_dummy_117;		// animation

	int						m_iAnimationInCaseDie;						// 118	// set according to hitplace and random values	// used when dies to set some properties (velocity, that kind of stuff)
	float						m_flNextChatTime;								
	
	bool						m_bHasReceivedDefItems;						// 120
	bool _bummy_501;					// 120
	bool _bummy_502;					// 120
	bool _bummy_503;					// 120

	int						m_iJoinedState;										// 121
/*
 * m_iJoinedState
	0 => first connect
	2 => stands to some state in HL where you can join the game using JUMP+ATTACK+ATTACK2
	3 => ready to choose team
	4 => team menu sent
	5 => player in game
 */
	CBaseEntity*		m_pLastCamera;									// 122
	float						m_flNextCameraTime;							// 123
	float						m_flLastActivityTime;								// 124

	bool						m_bHasBeenShownBriefing;					// 125
	bool						m_bHasChangeTeamThisRound;				// 125
	bool _bummy_522;					// 125
	bool _bummy_523;					// 125

	int						m_iInternalModel;									// 126
	int						m_iTeamMateKills;								// 127
	int						m_iIgnoreMessages;								// 128

	bool						m_bGotNVG;										// 129 // linux 536
	bool						m_bIsNVGSwitchedOn;							// lin 537
	short	 _dummy_no_occur_269;
	
	// 130win 135lin may be BuyPistols can't decompile...
	int  _dummy_omg[60];

	float						m_flNextIdleCheckTime;							// 190
	float						m_flNextRadioGameTime;						// 191
	int						m_iRadiosLeft;										// 192
	bool						m_bHasSilentRadio;								// 193
	bool						m_bHasC4;											// 193
	bool						m_bHasDefuser;									// 193
	bool						m_bBlastDamaged;								// 193

	Vector 					m_vecRelativeInflictorOrigin;					// 194
	int						m_bTruOnHeDamage;							// 197				// CBasePlayer::SetAnimation
	
	float						m_fNextHudTextArgsGameTime;			// 198
	int _HudTextArgs_Struct[5];
	int						m_bitHudTextArgsDontResend;				// 204

	int						m_iMenu;												// 205
	int _dummy_int206;
	int _dummy_134867;
	BOOL					m_fIsVIPRescued;									// 208
	
	bool						m_bHasReachRescueEscapePoint;		// 209
	bool						m_bIsVip;												// 209
	bool _bool_858;
	bool _bool_859;
	
	float						m_flNextRadarUpdateTime;					// 210
	Vector					m_vecLastPosition;								// 211-213
	int						m_iVoteKickUserId;								// 214
	float						m_flNextVote;										// 215 // votemap votekick
	int						m_iTeamKills;										// 216
	int						m_iHostageKills;									// 217
	int						m_iVotedMapIndex;								// 218
	BOOL					m_bIsPrimaryFireAllowed;						// 219
	float						m_flLastAttackTime;//??							// 220
	float						m_flNextTeammateAttackAlert;				// 221

	bool						m_bKilledByHeadShot;							// bool win 888	linux 908
	bool						m_bKilledBecauseTeamKill;					// bool win 889	linux 919
	bool						m_bNotReceivingMoneyNextRound;		// bool win 890	linux 920
	bool _bummy_921_no;

	float						m_flNextTimeleft;									// 223
	bool						m_bChangeNameAtRespawn;					// 224 //896
	char						m_szNewName[32];								// 224 //897

	// bool _bummy_232_0;	// let say name is 32 char and comment that one, would explain alignment better unless we find that offsets used in a bad decompiled function
	bool						m_bBombDefusing;
	bool _bummy_232_16;
	bool _bummy_232_24;
	// BOOL					m_fBombDefusing;									// 232

	float						m_flNextMapZoneTime;							// 233
	int						m_fMapZone;										// 234
	int						m_fClientMapZone;								// 235
	edict_t*					m_pentBombTarget;								// 236
	int						m_iPlayerSound;									// 237	// the index of the sound list slot reserved for this player
	int						m_iTargetVolume;									// 238	// ideal sound volume. 
	int						m_iWeaponVolume;								// 239	// how loud the player's weapon is right now.
	int						m_iExtraSoundTypes;							// 240	// additional classification for this weapon's sound
	int						m_iWeaponFlash;									// brightness of the weapon flash
	float						m_flStopExtraSoundTime;						// 
	
	float						m_flFlashLightTime;								// Time until next battery draw/Recharge
	int						m_iFlashBattery;									// Flashlight Battery Draw
	
	int						m_afButtonLast;									// 245
	int						m_afButtonPressed;								// 246
	int						m_afButtonReleased;								// 247
	
	edict_t*					m_pentSndLast;									// last sound entity to modify player room type
	float						m_flSndRoomtype;								// last roomtype set by sound entity
	float						m_flSndRange;										// dist from player to sound entity
	float						m_flFallVelocity;									// 251
	int						m_rgItems[5];
	unsigned int			m_afPhysicsFlags;								// 257	// physics flags - set when 'normal' physics should be revisited or overriden
	float						m_fNextSuicideTime; 							// the time after which the player can next use the suicide command
	// these are time-sensitive things that we keep track of
	float						m_flTimeStepSound;								// when the last stepping sound was made
	float						m_flTimeWeaponIdle;								 // when to play another weapon idle animation.
	float						m_flSwimTime;										// how long player has been underwater
	float						m_flDuckTime;										// how long we've been ducking
	float						m_flWallJumpTime;								// 263	// how long until next walljump
	float						m_flSuitUpdate;										// 264			// when to play next suit update
	int						m_rgSuitPlayList[4]; 								//[CSUITPLAYLIST] // next sentencenum to play for suit update
	int						m_iSuitPlayNext;									// 269			// next sentence slot for queue storage;
	int						m_rgiSuitNoRepeat[32]; 						//[CSUITNOREPEAT]		// suit sentence no repeat list
	float						m_rgflSuitNoRepeatTime[32];					//[CSUITNOREPEAT]	// how long to wait before allowing repeat
	int						m_lastDamageAmount;							// 334		// Last damage taken
	float						m_tbdPrev;											// Time-based damage timer
	float						m_flgeigerRange;									// range to nearest radiation source
	float						m_flgeigerDelay;									// delay per update of range msg to client
	int						m_igeigerRangePrev;
	int						m_iStepLeft;											// 339	// alternate left/right foot stepping sound
	char						m_szTextureName[19];							//HL 13 [CBTEXTURENAMEMAX]	// current texture name we're standing on
	char						m_chTextureType;									// current texture type
	int						m_idrowndmg;										// 345	// track drowning damage taken
	int						m_idrownrestored;									// track drowning damage restored
	int						m_bitsHUDDamage;								// Damage bits for the current fame. These get sent to 
	// the hude via the DAMAGE message
	BOOL					m_fInitHUD; // 348									// True when deferred HUD restart msg needs to be sent
	BOOL					m_fGameHUDInitialized;
	int						m_iTrain;												// Train control position
	BOOL					m_fWeapon;											// 351	// Set this to FALSE to force a reset of the current weapon HUD info
	EHANDLE				m_pTank;												// 352	// the tank which the player is currently controlling,  NULL if no tank
	float						m_fDeadTime;										// 354	// the time at which the player died  (used in PlayerDeathThink())
	BOOL					m_fNoPlayerSound;								// a debugging feature. Player makes no sound if this is true. 
	BOOL					m_fLongJump;										// does this player have the longjump module?
	float						m_tSneaking;
	int						m_iUpdateTime;									// stores the number of frame ticks before sending HUD update messages
	int						m_iClientHealth;									// the health currently known by the client.  If this changes, send a new
	int						m_iClientBattery;									// the Battery currently known by the client.  If this changes, send a new
	int						m_iHideHUD;										// the players hud weapon info is to be hidden
	int						m_iClientHideHUD;
	int						m_iFOV;												// field of view
	int						m_iClientFOV;										// client's known FOV
	int						m_iSpawnCount;									// 365WIN32
	CBaseEntity*		m_pLinkedEntity;									// if set, entity is removed when player disconnects
	// usable player items 
	CBasePlayerWeapon*	m_rgpPlayerItems[MAX_ITEM_TYPES];
	CBasePlayerWeapon*	m_pActiveItem;										// 373
	CBasePlayerWeapon*	m_pClientActiveItem;  							// client version of the active item
	CBasePlayerWeapon*	m_pLastItem;										// 375
	// shared ammo slots
	int						m_rgAmmo[MAX_AMMO_SLOTS];
	int						m_rgAmmoLast[MAX_AMMO_SLOTS];
	Vector					m_vecAutoAim;										// 440
	BOOL					m_fOnTarget;										// 443
	int						m_iDeaths; 											// 444
	float						m_iRespawnFrames;								// used in PlayerDeathThink() to make sure players can always respawn
	int						m_izSBarState[ 3 ]; 								// 446 // [SBAR_END]
	float						m_flNextSBarUpdateTime; 						// 449
	float						m_flStatusBarDisappearDelay; 				// 450
	char						m_SbarString0[ 128 ]; 							// 451 // 128/4=32 // [SBAR_STRING_SIZE]
	int						m_lastx;
	int						m_lasty;  												// 483 484 // These are the previous update's crosshair angles, DON"T SAVE/RESTORE
	int						m_nCustomSprayFrames;						//485// Custom clan logo frames for this player
	float						m_flNextDecalTime;								//486// next time this player can spray a decal // 382
	char						m_szTeamName[16];
	char*					g_szModelIndexPlayer;							 // 491
	char						m_szShieldAnimExt[28];
	int _dummy;	// 499
	int						m_iGaitSequence;									//500
	float						m_flGaitFrame;
	float						m_flGaitYaw;
	Vector					m_flPrevGaitOrigin; 								// 503
	float						m_flPitch;												// 506
	float						m_flYaw;
	float						m_flGaitMovement;
	float						m_fAutoWeaponSwitch;							//509
	bool						m_bHasVGUIMenus; 							//510	// 2040
	bool						m_bHasAutoHelp; 									//510	// 2041
	bool						m_bUsesShield; 									//510	// 2042
	bool						m_bHasShield; 										//510	// 2043
	BOOL					m_fObserverHasTarget;							// 511
	float						m_flFindNextPlayerTime;
	float						m_flDtMultiplier;
	float						m_flFlashedUntil;
	float						m_flFlashedAt;
	float						m_flFlashHoldTime;
	float						m_flFlashDuration;
	float						m_iFlashAlpha;
	float						m_flNextAutoFollowTime;						// 519
	char						m_szAutoBuyData[256]; 						// 520
	void* 					m_pSomeRebuyPointer; 						// Rebuy stuff CBasePlayer::Rebuy CBasePlayer::RebuyInitData ClientPutInServer
	int						m_iRebuyLastPrimaryItemId;					// 585
	int						m_iRebuyLastPrimaryItemAmmo;
	int						m_iRebuyLastSecondaryItemId;
	int						m_iRebuyLastSecondaryItemAmmo;
	int						m_iRebuyHEGrenadeAmmo;
	int						m_iRebuyFlashbangAmmo;
	int						m_iRebuySmokeGrenadeAmmo;
	int						m_iRebuyDefuseKit;
	int						m_iRebuyNVGoggles;
	int						m_iRebuyKevlar;
	BOOL					m_bRebuyStructBuilt; 							// 595
	float						m_flNextLocationUpdateTime; 				// 596
	char						m_szLocation[32]; 								// 597-604 win // 602-619 linux
	float						m_flProgressBarStartTime;						// 605
	float						m_flProgressBarEndTime;						// 606
	bool						m_bObserverAutoDirector; 						// 607	// "spec_set_ad" ClientCommand
	bool						m_bCanSwitchObserverModes; 				// BYTE 607*4 + 1
	bool _bummy_2450_no;														// 2450 linux
	bool _bummy_2451_no;														// 2451 linux

	int _dummy_2452_no;

	float						m_flIntense;											// 609 win // ?void? CBasePlayer::Intense() { m_flIntense = gpGlobals->time; }

	double _dummy_2460_no;
	
	float						m_flNextSayTime; 								// 612
	float						m_flNextSayTeamTime; 						// 613
	float						m_flNextFullUpdateTime; 						// 614
	float						m_flNextVoteTimeCmd; 							// 615
	float						m_flNextVoteMapTime; 							// 616
	float						m_flNextListMapsTime; 							// 617
	float						m_flNextListPlayersTime; 						// 618
	float						m_flNextNightVisionTime; 						// 619	

} CBasePlayer_t;

typedef struct CEnvExplosion_t CEnvExplosion;
typedef struct CEnvExplosion_s
{

	_vt_CEnvExplosion*		vtable;	
	#include "./offsets_cbasemonster.h"

	int			m_iMagnitude;
	int			m_spriteScale;

} CEnvExplosion_t;

typedef struct CWreckage_t CWreckage;
typedef struct CWreckage_s
{

	_vt_CWreckage*		vtable;
	#include "./offsets_cbasemonster.h"
	
	float		m_flStartTime;	
	
} CWreckage_t;
	
typedef struct CGunTarget_t CGunTarget;
typedef struct CGunTarget_s
{

	_vt_CGunTarget*		vtable;
	#include "./offsets_cbasemonster.h"
	
	bool		m_on;	
	
} CGunTarget_t;

typedef struct CDeadHEV_t CDeadHEV;
typedef struct CDeadHEV_s
{

	_vt_CDeadHEV*		vtable;
	#include "./offsets_cbasemonster.h"
	
	int	m_iPose;							// offset 101 size 1 // which sequence to display	-- temporary, don't need to save
	
} CDeadHEV_t;
	
#endif
