/***
*
*    Copyright (c) 1996-2002, Valve LLC. All rights reserved.
*
*    This product contains software technology licensed from Id
*    Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc.
*    All Rights Reserved.
*
*    Compiling or running this code may violate patents in certain countries.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/

#ifndef CBASEPLAYERWEAPON__H
#define CBASEPLAYERWEAPON__H

typedef struct CBasePlayerWeapon_t CBasePlayerWeapon;
typedef struct CBasePlayerWeapon_s
{
	_vt_CBasePlayerWeapon*		vtable;
	#include "./offsets_cbaseplayerweapon.h"

} CBasePlayerWeapon_t;
	
typedef struct CHEGrenade_t CHEGrenade;
typedef struct CHEGrenade_s
{
	_vt_CHEGrenade*		vtable;
	#include "./offsets_cbaseplayerweapon.h"

	unsigned short		m_usExplo;			// offset 82
	unsigned short		_dummy_81_01;		// offset 82

} CHEGrenade_t;

typedef struct CAK47_t CAK47;
typedef struct CAK47_s
{
	_vt_CAK47*		vtable;
	#include "./offsets_cbaseplayerweapon.h"

	int		m_iShell;						// offset 82
	int		m_fIsDeployed;					// offset 83
	unsigned short		m_usWeaponEvent;	// offset 84
	unsigned short		_dummy_84_01;		// offset 84
	
} CAK47_t;

typedef struct CAUG_t CAUG;
typedef struct CAUG_s
{
	_vt_CAUG*		vtable;
	#include "./offsets_cbaseplayerweapon.h"

	int		m_iShell;						// offset 82
	int		m_fIsDeployed;					// offset 83
	unsigned short		m_usWeaponEvent;	// offset 84
	unsigned short		_dummy_84_01;		// offset 84
	
} CAUG_t;

typedef struct CDEAGLE_t CDEAGLE;
typedef struct CDEAGLE_s
{
	_vt_CDEAGLE*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int		m_iShell;						// offset 82
	unsigned short		m_usWeaponEvent;	// offset 83
	unsigned short		_dummy_84_01;		// offset 83
	
} CDEAGLE_t;

typedef struct CELITE_t CELITE;
typedef struct CELITE_s
{
	_vt_CELITE*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int		m_iShell;						// offset 82
	unsigned short		m_usWeaponEventLeft;	// offset 83
	unsigned short		m_usWeaponEventRigth;	// offset 83
	
} CELITE_t;

typedef struct CFiveSeven_t CFiveSeven;
typedef struct CFiveSeven_s
{
	_vt_CFiveSeven*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int		m_iShell;						// offset 82
	unsigned short		m_usWeaponEvent;	// offset 83
	unsigned short		_dummy_84_01;		// offset 83
	
} CFiveSeven_t;

typedef struct CM249_t CM249;
typedef struct CM249_s
{
	_vt_CM249*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int		m_iShell;						// offset 82
	int		m_fIsDeployed;					// offset 83
	unsigned short		m_usWeaponEvent;	// offset 84
	unsigned short		_dummy_84_01;		// offset 84
	
} CM249_t;

typedef struct CM4A1_t CM4A1;
typedef struct CM4A1_s
{
	_vt_CM4A1*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int		m_iShell;						// offset 82
	int		m_fIsDeployed;					// offset 83
	unsigned short		m_usWeaponEvent;	// offset 84
	unsigned short		_dummy_84_01;		// offset 84
	
} CM4A1_t;

typedef struct CMAC10_t CMAC10;
typedef struct CMAC10_s
{
	_vt_CMAC10*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int		m_iShell;						// offset 82
	int		m_fIsDeployed;					// offset 83
	unsigned short		m_usWeaponEvent;	// offset 84
	unsigned short		_dummy_84_01;		// offset 84
	
} CMAC10_t;

typedef struct CMP5N_t CMP5N;
typedef struct CMP5N_s
{
	_vt_CMP5N*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int		m_iShell;						// offset 82
	int		m_fIsDeployed;					// offset 83
	unsigned short		m_usWeaponEvent;	// offset 84
	unsigned short		_dummy_84_01;		// offset 84
	
} CMP5N_t;

typedef struct CP228_t CP228;
typedef struct CP228_s
{
	_vt_CP228*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int		m_iShell;						// offset 82
	unsigned short		m_usWeaponEvent;	// offset 83
	unsigned short		_dummy_84_01;		// offset 83
	
} CP228_t;

typedef struct CP90_t CP90;
typedef struct CP90_s
{
	_vt_CP90*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int		m_iShell;						// offset 82
	int		m_fIsDeployed;					// offset 83
	unsigned short		m_usWeaponEvent;	// offset 84
	unsigned short		_dummy_84_01;		// offset 84
	
} CP90_t;

typedef struct CSG552_t CSG552;
typedef struct CSG552_s
{
	_vt_CSG552*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int		m_iShell;						// offset 82
	int		m_fIsDeployed;					// offset 83
	unsigned short		m_usWeaponEvent;	// offset 84
	unsigned short		_dummy_84_01;		// offset 84
	
} CSG552_t;

typedef struct CTMP_t CTMP;
typedef struct CTMP_s
{
	_vt_CTMP*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int		m_iShell;						// offset 82
	int		m_fIsDeployed;					// offset 83
	unsigned short		m_usWeaponEvent;	// offset 84
	unsigned short		_dummy_84_01;		// offset 84
	
} CTMP_t;

typedef struct CUMP45_t CUMP45;
typedef struct CUMP45_s
{
	_vt_CUMP45*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int		m_iShell;						// offset 82
	int		m_fIsDeployed;					// offset 83
	unsigned short		m_usWeaponEvent;	// offset 84
	unsigned short		_dummy_84_01;		// offset 84
	
} CUMP45_t;

typedef struct CUSP_t CUSP;
typedef struct CUSP_s
{
	_vt_CUSP*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int		m_iShell;						// offset 82
	unsigned short		m_usWeaponEvent;	// offset 83
	unsigned short		_dummy_84_01;		// offset 83
	
} CUSP_t;

typedef struct CGalil_t CGalil;
typedef struct CGalil_s
{
	_vt_CGalil*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int		m_iShell;						// offset 82
	int		m_fIsDeployed;					// offset 83
	unsigned short		m_usWeaponEvent;	// offset 84
	unsigned short		_dummy_84_01;		// offset 84
	
} CGalil_t;

typedef struct CFamas_t CFamas;
typedef struct CFamas_s
{
	_vt_CFamas*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int		m_iShell;						// offset 82
	int		m_fIsDeployed;					// offset 83

} CFamas_t;

typedef struct CGLOCK18_t CGLOCK18;
typedef struct CGLOCK18_s
{
	_vt_CGLOCK18*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int		m_iShell;						// offset 82
	int		m_fIsDeployed;					// offset 83
	
} CGLOCK18_t;

typedef struct CSmokeGrenade_t CSmokeGrenade;
typedef struct CSmokeGrenade_s
{
	_vt_CSmokeGrenade*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	unsigned short		m_usWeaponEvent;	// offset 82
	unsigned short		_dummy_82_01;		// offset 82
	
} CSmokeGrenade_t;

typedef struct CSCOUT_t CSCOUT;
typedef struct CSCOUT_s
{
	_vt_CSCOUT*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int						m_iShell;					// offset 82
	unsigned short		m_usWeaponEvent;	// offset 83
	unsigned short		_dummy_82_01;		// offset 83
	
} CSCOUT_t;

typedef struct CAWP_t CAWP;
typedef struct CAWP_s
{
	_vt_CAWP*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int						m_iShell;					// offset 82
	unsigned short		m_usWeaponEvent;	// offset 83
	unsigned short		_dummy_82_01;		// offset 83
	
} CAWP_t;

typedef struct CSG550_t CSG550;
typedef struct CSG550_s
{
	_vt_CSG550*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int						m_iShell;					// offset 82
	unsigned short		m_usWeaponEvent;	// offset 83
	unsigned short		_dummy_82_01;		// offset 83
	
} CSG550_t;

typedef struct CG3SG1_t CG3SG1;
typedef struct CG3SG1_s
{
	_vt_CG3SG1*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int						m_iShell;					// offset 82
	unsigned short		m_usWeaponEvent;	// offset 83
	unsigned short		_dummy_82_01;		// offset 83
	
} CG3SG1_t;

typedef struct CFlashbang_t CFlashbang;
typedef struct CFlashbang_s
{
	_vt_CFlashbang*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
} CFlashbang_t;

typedef struct CXM1014_t CXM1014;
typedef struct CXM1014_s
{
	_vt_CXM1014*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int						m_iShell;					// offset 82
	float						m_flPumpTime;			// offset 83
	unsigned short		m_usWeaponEvent;	// offset 84
	unsigned short		_dummy_82_01;		// offset 84
	
} CXM1014_t;

typedef struct CM3_t CM3;
typedef struct CM3_s
{
	_vt_CM3*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int						m_iShell;					// offset 82
	float						m_flPumpTime;			// offset 83
	unsigned short		m_usWeaponEvent;	// offset 84
	unsigned short		_dummy_82_01;		// offset 84
	
} CM3_t;

typedef struct CC4_t CC4;
typedef struct CC4_s
{
	_vt_CC4*		vtable;
	#include "./offsets_cbaseplayerweapon.h"

	bool 					m_bArming;					// offset 82		
	bool 					m_bInArmingAnimation;	// offset 82
	bool					_dummy_bool_330;
	bool					_dummy_bool_331;

	float					m_flArmedTime;		// offset 83
	int					_dummy_80;				// offset 84
	
} CC4_t;

typedef struct CKnife_t CKnife;
typedef struct CKnife_s
{
	_vt_CKnife*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	TraceResult			m_trHit;					// offset 82
	unsigned short		m_usWeaponEvent;	// offset 96
	unsigned short		_dummy_96_1;
	
} CKnife_t;

typedef struct CWeaponCycler_t CWeaponCycler;
typedef struct CWeaponCycler_s
{
	_vt_CWeaponCycler*		vtable;
	#include "./offsets_cbaseplayerweapon.h"
	
	int 		m_iszModel;		// offset 82 size 1
	int 		m_iModel;			// offset 83 size 1
	
} CWeaponCycler_t;

#endif
