/***
*
*    Copyright (c) 1996-2002, Valve LLC. All rights reserved.
*
*    This product contains software technology licensed from Id
*    Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc.
*    All Rights Reserved.
*
*    Compiling or running this code may violate patents in certain countries.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/

#ifndef CBASETOGGLE__H
#define CBASETOGGLE__H

#define MAX_MULTI_TARGETS	16 // maximum number of targets a single multi_manager entity may be assigned.

typedef struct CBaseToggle_t CBaseToggle;
typedef struct CBaseToggle_s
{
	_vt_CBaseToggle*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CBaseToggle_t;

typedef struct CMomentaryRotButton_t CMomentaryRotButton;
typedef struct CMomentaryRotButton_s
{
	_vt_CMomentaryRotButton*		vtable;
	#include "./offsets_cbasetoggle.h"
	
	int		m_lastUsed;			// 73
	int		m_direction;			// 74
	float		m_returnSpeed;			// 75
	vec3_t		m_start;			// 76
	vec3_t		m_end;				// 79
	int		m_sounds;			// 82

} CMomentaryRotButton_t;

typedef struct CMomentaryDoor_t CMomentaryDoor;
typedef struct CMomentaryDoor_s
{
	_vt_CMomentaryDoor*		vtable;
	#include "./offsets_cbasetoggle.h"
	
	BYTE		m_bMoveSnd;				// sound a door makes while moving	

} CMomentaryDoor_t;

typedef struct CWallHealth_t CWallHealth;
typedef struct CWallHealth_s
{
	_vt_CWallHealth*		vtable;
	#include "./offsets_cbasetoggle.h"
	
	float		m_flNextCharge; 
	int		m_iReactivate;				// DeathMatch Delay until reactvated
	int		m_iJuice;
	int		m_iOn;					// 0 = off, 1 = startup, 2 = going
	float		m_flSoundTime;

} CWallHealth_t;

typedef struct CRecharge_t CRecharge;
typedef struct CRecharge_s
{
	_vt_CRecharge*		vtable;
	#include "./offsets_cbasetoggle.h"
	
	float		m_flNextCharge; 
	int		m_iReactivate;				// DeathMatch Delay until reactvated
	int		m_iJuice;
	int		m_iOn;					// 0 = off, 1 = startup, 2 = going
	float		m_flSoundTime;

} CRecharge_t;

typedef struct CMultiManager_t CMultiManager;
typedef struct CMultiManager_s
{
	_vt_CMultiManager*		vtable;
	#include "./offsets_cbasetoggle.h"
	
	int		m_cTargets;				// the total number of targets in this manager's fire list.
	int		m_index;				// Current target
	float		m_startTime;				// Time we started firing
	int		m_iTargetName[MAX_MULTI_TARGETS];	// list if indexes into global string array
	float		m_flTargetDelay[MAX_MULTI_TARGETS];	// delay (in seconds) from time of manager fire to target fire

} CMultiManager_t;

typedef struct CFuncIllusionary_t CFuncIllusionary;
typedef struct CFuncIllusionary_s
{
	_vt_CFuncIllusionary*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CFuncIllusionary_t;

typedef struct CFuncMortarField_t CFuncMortarField;
typedef struct CFuncMortarField_s
{
	_vt_CFuncMortarField*		vtable;
	#include "./offsets_cbasetoggle.h"

	int m_iszXController;		// offset 78 // size 1
	int m_iszYController;		// offset 79 // size 1
	float m_flSpread;			// offset 80 // size 1
	float m_flMortarDelay;				// offset 81 // size 1
	int m_iCount;					// offset 82 // size 1
	int m_fControl;				// offset 83 // size 1

} CFuncMortarField_t;

#endif
