/***
*
*    Copyright (c) 1996-2002, Valve LLC. All rights reserved.
*
*    This product contains software technology licensed from Id
*    Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc.
*    All Rights Reserved.
*
*    Compiling or running this code may violate patents in certain countries.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/

#ifndef CBASETRIGGER__H
#define CBASETRIGGER__H

typedef struct CBaseTrigger_t CBaseTrigger;
typedef struct CBaseTrigger_s
{

	_vt_CBaseTrigger*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CBaseTrigger_t;

typedef struct CBombTarget_t CBombTarget;
typedef struct CBombTarget_s
{

	_vt_CBombTarget*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CBombTarget_t;

typedef struct CBuyZone_t CBuyZone;
typedef struct CBuyZone_s
{

	_vt_CBuyZone*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CBuyZone_t;

typedef struct CEscapeZone_t CEscapeZone;
typedef struct CEscapeZone_s
{

	_vt_CEscapeZone*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CEscapeZone_t;

typedef struct CHostageRescue_t CHostageRescue;
typedef struct CHostageRescue_s
{

	_vt_CBaseTrigger*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CHostageRescue_t;

typedef struct CLadder_t CLadder;
typedef struct CLadder_s
{

	_vt_CLadder*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CLadder_t;

typedef struct CTriggerCDAudio_t CTriggerCDAudio;
typedef struct CTriggerCDAudio_s
{

	_vt_CTriggerCDAudio*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CTriggerCDAudio_t;

typedef struct CTriggerCounter_t CTriggerCounter;
typedef struct CTriggerCounter_s
{

	_vt_CTriggerCounter*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CTriggerCounter_t;

typedef struct CTriggerEndSection_t CTriggerEndSection;
typedef struct CTriggerEndSection_s
{

	_vt_CTriggerEndSection*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CTriggerEndSection_t;

typedef struct CTriggerGravity_t CTriggerGravity;
typedef struct CTriggerGravity_s
{

	_vt_CTriggerGravity*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CTriggerGravity_t;

typedef struct CTriggerHurt_t CTriggerHurt;
typedef struct CTriggerHurt_s
{

	_vt_CTriggerHurt*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CTriggerHurt_t;

typedef struct CTriggerMonsterJump_t CTriggerMonsterJump;
typedef struct CTriggerMonsterJump_s
{

	_vt_CTriggerMonsterJump*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CTriggerMonsterJump_t;

typedef struct CTriggerPush_t CTriggerPush;
typedef struct CTriggerPush_s
{

	_vt_CTriggerPush*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CTriggerPush_t;

typedef struct CTriggerSave_t CTriggerSave;
typedef struct CTriggerSave_s
{

	_vt_CTriggerSave*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CTriggerSave_t;

typedef struct CTriggerTeleport_t CTriggerTeleport;
typedef struct CTriggerTeleport_s
{

	_vt_CTriggerTeleport*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CTriggerTeleport_t;

typedef struct CVIP_SafetyZone_t CVIP_SafetyZone;
typedef struct CVIP_SafetyZone_s
{

	_vt_CVIP_SafetyZone*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CVIP_SafetyZone_t;

typedef struct CWeather_t CWeather;
typedef struct CWeather_s
{

	_vt_CWeather*		vtable;
	#include "./offsets_cbasetoggle.h"
	
} CWeather_t;

#define cchMapNameMost 32

typedef struct CChangeLevel_t CChangeLevel;
typedef struct CChangeLevel_s
{

	_vt_CChangeLevel*		vtable;
	#include "./offsets_cbasetoggle.h"
	
	char m_szMapName[cchMapNameMost];			// offset 78 size 32// trigger_changelevel only:  next map	// offset 78 size 32
	char m_szLandmarkName[cchMapNameMost];	// offset 86 size 32	// trigger_changelevel only:  landmark on next map
	int		m_changeTarget;									// offset 94 size 1
	float	m_changeTargetDelay;								// offset 95 size 1
} CChangeLevel_t;

#endif
