/***
*
*    Copyright (c) 1996-2002, Valve LLC. All rights reserved.
*
*    This product contains software technology licensed from Id
*    Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc.
*    All Rights Reserved.
*
*    Compiling or running this code may violate patents in certain countries.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/

#ifndef CBEAM__H
#define CBEAM__H

typedef struct CBeam_t CBeam;
typedef struct CBeam_s
{
	_vt_CBeam*		vtable;
	#include "./offsets_cbaseentity.h"
	
} CBeam_t;


typedef struct CLaser_t CLaser;
typedef struct CLaser_s
{
	_vt_CLaser*		vtable;
	#include "./offsets_cbaseentity.h"

	CSprite*		m_pSprite;
	int		m_iszSpriteName;
	Vector		m_firePosition;

} CLaser_t;

typedef struct CLightning_t CLightning;
typedef struct CLightning_s
{
	_vt_CLightning*		vtable;
	#include "./offsets_cbaseentity.h"
	
	int		m_active;
	int		m_iszStartEntity;
	int		m_iszEndEntity;
	float		m_life;
	int		m_boltWidth;
	int		m_noiseAmplitude;
	int		m_brightness;
	int		m_speed;
	float		m_restrike;
	int		m_spriteTexture;
	int		m_iszSpriteName;
	int		m_frameStart;

	float		m_radius;

} CLightning_t;

#endif
