/***
*
*    Copyright (c) 1996-2002, Valve LLC. All rights reserved.
*
*    This product contains software technology licensed from Id
*    Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc.
*    All Rights Reserved.
*
*    Compiling or running this code may violate patents in certain countries.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/

#ifndef CCAREERTASK__H
#define CCAREERTASK__H

typedef struct CCareerTask_t CCareerTask;

typedef struct CareerTypeInfo_t CareerTypeInfo;
typedef struct CareerTypeInfo_s
{
		char*		m_szTaskName;
		int		m_iTaskType;
		CCareerTask*		(*CCareerTask__NewTask)(CCareerTask *this, const char *taskName, int taskType, const char *taskWeapon, bool bNeedProgression, bool bSurvive, bool bInARow);
} CareerTypeInfo_t;


typedef struct CCareerTask_s
{
#ifndef __linux__
	_vt_CCareerTask* vtbl;
#endif

	bool		m_bComplete;
	bool _dummy_careertask_0_2_not_used;
	bool _dummy_careertask_0_3_not_used;
	bool _dummy_careertask_0_4_not_used;
	const char*					m_pszTaskName;	// char[] ? char* ?
	int						m_iTaskIndex; // Event Index to Complete Task ?
	GameEventType		m_iTaskType;
	int						m_iTaskNeededProgression;
	int						m_iTaskProgression;
	bool		m_bSurvive;
	bool		m_bInARow;
	bool		m_bPartiallyCompleted;
	bool _dummy_careertask_6_4_not_used;
	int						m_iWeaponId;
	int						m_iWeaponClassId;
	bool		m_bStopRescue;
	bool						m_bKillDefuser;
	bool						m_bKillVip;
	bool _dummy_careertask_9_4_not_used;

#ifdef __linux__
	_vt_CCareerTask* vtbl;
#endif
} CCareerTask_t;

typedef struct CCareerTaskManager_t CCareerTaskManager;
typedef struct CCareerTaskManager_s
{
	CCareerTaskManager*		m_iNextId;
	CCareerTaskManager*		m_iPrevId;
	CCareerTask*	m_CareerTask;

	int		m_iWinFast;
	int		m_iWinFastInARow;
	int		m_iMaxRounds;
	GameEventType		m_iLastLatchedevent;
	bool		m_bLatchedRoundEnd;
		
} CCareerTaskManager_t;
	
#endif
