/***
*
*    Copyright (c) 1996-2002, Valve LLC. All rights reserved.
*
*    This product contains software technology licensed from Id
*    Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc.
*    All Rights Reserved.
*
*    Compiling or running this code may violate patents in certain countries.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/

#ifndef CHINTMESSAGE__H
#define CHINTMESSAGE__H

typedef struct CUtlMemory_t CUtlMemory;
typedef struct CUtlMemory_s
{
	void* m_pMemory;
	int m_nAllocationCount;
	int m_nGrowSize;
} CUtlMemory_t;

typedef struct CUtlVector_t CUtlVector;
typedef struct CUtlVector_s
{
	CUtlMemory		m_Memory;
	int		m_iSize;
	CUtlVector*		m_pElements;
} CUtlVector_t;

typedef struct CHintMessage_t CHintMessage;
typedef struct CHintMessage_s
{
	char *	m_hintString;
	CUtlVector		m_args;
	float		m_duration;
/*
 * check in CHintMessage::CHintMessage for some overflow in CHintMessage
 * Symbols for CUtlVector, CUtlMemory, CHintMessage, CHintMessageQueue should be updated
 * 
 * references
 * http://hlssmod.net/he_code/game/shared/hintmessage.h
 * http://hlssmod.net/he_code/game/shared/hintmessage.cpp
 * http://hlssmod.net/he_code/public/tier1/utlvector.h
 *
	bool							m_bInitHUDstyle;	// http://wiki.amxmodx.org/Half-Life_1_Game_Events#HudTextArgs
	bool		_dummy_CHintMessage_1_1;
	bool		_dummy_CHintMessage_1_2;
	bool		_dummy_CHintMessage_1_3;
	CUtlVector*		m_pSubMessages;
	int	_dummy_CHintMessage_3;
	int _dummy_CHintMessage_4;
	int 	m_SubMessagesNum;
	int _dummy_CHintMessage_6;
	int _dummy_CHintMessage_7;
	int _dummy_CHintMessage_10based[1000];
*/
	
} CHintMessage_t;

typedef struct CHintMessageQueue_t CHintMessageQueue;
typedef struct CHintMessageQueue_s
{
	float	 m_tmMessageEnd;
	CUtlVector		m_messages;
	CBasePlayer *m_pPlayer;
} CHintMessageQueue_t;

#endif
