/***
*
*    Copyright (c) 1996-2002, Valve LLC. All rights reserved.
*
*    This product contains software technology licensed from Id
*    Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc.
*    All Rights Reserved.
*
*    Compiling or running this code may violate patents in certain countries.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/

typedef struct CBaseAnimating_t CBaseToggle;
typedef struct CBaseAnimating_t CBasePlayerItem;
typedef struct CBaseAnimating_t CBasePlayerWeapon;
typedef struct CBaseEntity_t CFuncWall;
typedef struct CBaseEntity_t CFuncWallToggle;
typedef struct CBaseEntity_t CFuncConveyor;
typedef struct CBaseEntity_t CFuncMonsterClip;
typedef struct CBaseEntity_t CFuncRotating;
typedef struct CBaseEntity_t CPendulum;
typedef struct CBaseEntity_t CEnvSpark;
typedef struct CBaseEntity_t CButtonTarget;
typedef struct CBaseEntity_t CGib;
typedef struct CBaseEntity_t CBeam;
typedef struct CBaseEntity_t CLaser;
typedef struct CBaseEntity_t CBubbling;
typedef struct CBaseEntity_t CLightning;
typedef struct CBaseEntity_t CItemSoda;
typedef struct CBaseEntity_t CShower;
typedef struct CBaseEntity_t CFuncTank;
typedef struct CBaseEntity_t CFuncTankGun;
typedef struct CBaseEntity_t CFuncTankLaser;
typedef struct CBaseEntity_t CFuncTankRocket;
typedef struct CBaseEntity_t CFuncTankMortar;
typedef struct CBaseEntity_t CFuncTankControls;
typedef struct CBaseEntity_t CCyclerSprite;
typedef struct CBaseEntity_t CItem;
typedef struct CBaseEntity_t CWorldItem;
typedef struct CBaseEntity_t CRuleEntity;
typedef struct CBaseEntity_t CRulePointEntity;
typedef struct CBaseEntity_t CRuleBrushEntity;
typedef struct CBaseEntity_t CGameScore;
typedef struct CBaseEntity_t CGameEnd;
typedef struct CBaseEntity_t CGameText;
typedef struct CBaseEntity_t CGameTeamMaster;
typedef struct CBaseEntity_t CGameTeamSet;
typedef struct CBaseEntity_t CGamePlayerZone;
typedef struct CBaseEntity_t CGamePlayerHurt;
typedef struct CBaseEntity_t CGameCounter;
typedef struct CBaseEntity_t CGameCounterSet;
typedef struct CBaseEntity_t CGamePlayerEquip;
typedef struct CBaseEntity_t CGamePlayerTeam;
typedef struct CBaseEntity_t CFuncTrackTrain;
typedef struct CBaseEntity_t CFuncTrainControls;
typedef struct CBaseEntity_t CWShield;
typedef struct CBaseEntity_t CSprayCan;
typedef struct CBaseEntity_t CBloodSplat;
typedef struct CBaseEntity_t CAmbientGeneric;
typedef struct CBaseEntity_t CSoundEnt;
typedef struct CBaseEntity_t CBaseSpectator;
typedef struct CBaseEntity_t CPointEntity;
typedef struct CBaseEntity_t CBaseDelay;
typedef struct CBaseEntity_t CNullEntity;
typedef struct CBaseEntity_t CBaseDMStart;
typedef struct CBaseEntity_t CBaseGrenCatch;
typedef struct CBaseEntity_t CFuncWeaponCheck;
typedef struct CBaseEntity_t CClientFog;
typedef struct CBaseEntity_t CRenderFxManager;
typedef struct CBaseEntity_t CFuncVehicle;
typedef struct CBaseEntity_t CFuncVehicleControls;
typedef struct CBaseEntity_t CBasePlayerAmmo;
typedef struct CBaseEntity_t CWeaponBox;
typedef struct CBaseEntity_t CArmoury;
typedef struct CBaseEntity_t CWorld;
typedef struct CBaseEntity_t CDecal;
typedef struct CBaseEntity_t CCorpse;
typedef struct CGameRules_t CHalfLifeMultiplay;
typedef struct CGameRules_t CHalfLifeRules;
typedef struct CGrenade_t CAirtank;
typedef struct CGrenade_t CMortar;
typedef struct CItem_t CHealthKit;
typedef struct CItem_t CItemSuit;
typedef struct CItem_t CItemBattery;
typedef struct CItem_t CItemAntidote;
typedef struct CItem_t CItemSecurity;
typedef struct CItem_t CItemLongJump;
typedef struct CItem_t CItemKevlar;
typedef struct CItem_t CItemAssaultSuit;
typedef struct CItem_t CItemThighPack;
typedef struct CBaseMonster_t CEnvExplosion;
typedef struct CBaseMonster_t CGrenade;
typedef struct CBaseMonster_t CCycler;
typedef struct CBaseMonster_t CGenericCycler;
typedef struct CBaseMonster_t CCyclerProbe;
typedef struct CBaseMonster_t CWreckage;
typedef struct CBaseMonster_t CGunTarget;
typedef struct CBaseMonster_t CBasePlayer;
typedef struct CBaseMonster_t CDeadHEV;
typedef struct CBaseMonster_t CHostage;
typedef struct CHalfLifeMultiplay_t CHalfLifeTraining;
typedef struct CFuncTrackChange_t CFuncTrackAuto;
typedef struct CBaseToggle_t CFuncIllusionary;
typedef struct CBaseToggle_t CBaseButton;
typedef struct CBaseToggle_t CRotButton;
typedef struct CBaseToggle_t CMomentaryRotButton;
typedef struct CBaseToggle_t CBaseDoor;
typedef struct CBaseToggle_t CRotDoor;
typedef struct CBaseToggle_t CMomentaryDoor;
typedef struct CBaseToggle_t CRecharge;
typedef struct CBaseToggle_t CWallHealth;
typedef struct CBaseToggle_t CFuncMortarField;
typedef struct CBaseToggle_t CBaseMonster;
typedef struct CBaseToggle_t CFuncTrackChange;
typedef struct CBaseToggle_t CBasePlatTrain;
typedef struct CBaseToggle_t CFuncPlat;
typedef struct CBaseToggle_t CFuncPlatRot;
typedef struct CBaseToggle_t CFuncTrain;
typedef struct CBaseToggle_t CMultiManager;
typedef struct CBaseToggle_t CBaseTrigger;
typedef struct CBaseToggle_t CTriggerHurt;
typedef struct CBaseToggle_t CTriggerMonsterJump;
typedef struct CBaseToggle_t CTriggerCDAudio;
typedef struct CBaseToggle_t CTriggerMultiple;
typedef struct CBaseToggle_t CTriggerOnce;
typedef struct CBaseToggle_t CTriggerCounter;
typedef struct CBaseToggle_t CChangeLevel;
typedef struct CBaseToggle_t CLadder;
typedef struct CBaseToggle_t CTriggerPush;
typedef struct CBaseToggle_t CTriggerTeleport;
typedef struct CBaseToggle_t CBuyZone;
typedef struct CBaseToggle_t CBombTarget;
typedef struct CBaseToggle_t CHostageRescue;
typedef struct CBaseToggle_t CEscapeZone;
typedef struct CBaseToggle_t CVIP_SafetyZone;
typedef struct CBaseToggle_t CTriggerSave;
typedef struct CBaseToggle_t CTriggerEndSection;
typedef struct CBaseToggle_t CTriggerGravity;
typedef struct CBaseToggle_t CWeather;
typedef struct CBaseDelay_t CBaseAnimating;
typedef struct CBaseDelay_t CGibShooter;
typedef struct CBaseDelay_t CEnvShooter;
typedef struct CBaseDelay_t CTestEffect;
typedef struct CBaseDelay_t CEnvFunnel;
typedef struct CBaseDelay_t CEnvBeverage;
typedef struct CBaseDelay_t CBreakable;
typedef struct CBaseDelay_t CPushable;
typedef struct CBaseDelay_t CAutoTrigger;
typedef struct CBaseDelay_t CTriggerRelay;
typedef struct CBaseDelay_t CFireAndDie;
typedef struct CBaseDelay_t CTriggerChangeTarget;
typedef struct CBaseDelay_t CTriggerCamera;
typedef struct CPointEntity_t CMultiSource;
typedef struct CPointEntity_t CEnvGlobal;
typedef struct CPointEntity_t CSprite;
typedef struct CPointEntity_t CGlow;
typedef struct CPointEntity_t CBombGlow;
typedef struct CPointEntity_t CBlood;
typedef struct CPointEntity_t CShake;
typedef struct CPointEntity_t CFade;
typedef struct CPointEntity_t CMessage;
typedef struct CPointEntity_t CLight;
typedef struct CPointEntity_t CEnvLight;
typedef struct CPointEntity_t CMapInfo;
typedef struct CPointEntity_t CPathTrack;
typedef struct CPointEntity_t CPathCorner;
typedef struct CPointEntity_t CStripWeapons;
typedef struct CPointEntity_t CRevertSaved;
typedef struct CPointEntity_t CInfoIntermission;
typedef struct CPointEntity_t CEnvSound;
typedef struct CPointEntity_t CTargetCDAudio;
typedef struct CPointEntity_t CTriggerVolume;
typedef struct CBasePlayerAmmo_t C9MMAmmo;
typedef struct CBasePlayerAmmo_t CBuckShotAmmo;
typedef struct CBasePlayerAmmo_t C556NatoAmmo;
typedef struct CBasePlayerAmmo_t C556NatoBoxAmmo;
typedef struct CBasePlayerAmmo_t C762NatoAmmo;
typedef struct CBasePlayerAmmo_t C45ACPAmmo;
typedef struct CBasePlayerAmmo_t C50AEAmmo;
typedef struct CBasePlayerAmmo_t C338MagnumAmmo;
typedef struct CBasePlayerAmmo_t C57MMAmmo;
typedef struct CBasePlayerAmmo_t C357SIGAmmo;
typedef struct CBasePlayerWeapon_t CWeaponCycler;
typedef struct CBasePlayerWeapon_t CAK47;
typedef struct CBasePlayerWeapon_t CAUG;
typedef struct CBasePlayerWeapon_t CAWP;
typedef struct CBasePlayerWeapon_t CC4;
typedef struct CBasePlayerWeapon_t CDEAGLE;
typedef struct CBasePlayerWeapon_t CELITE;
typedef struct CBasePlayerWeapon_t CFiveSeven;
typedef struct CBasePlayerWeapon_t CFlashbang;
typedef struct CBasePlayerWeapon_t CG3SG1;
typedef struct CBasePlayerWeapon_t CGLOCK18;
typedef struct CBasePlayerWeapon_t CHEGrenade;
typedef struct CBasePlayerWeapon_t CKnife;
typedef struct CBasePlayerWeapon_t CM249;
typedef struct CBasePlayerWeapon_t CM3;
typedef struct CBasePlayerWeapon_t CM4A1;
typedef struct CBasePlayerWeapon_t CMAC10;
typedef struct CBasePlayerWeapon_t CMP5N;
typedef struct CBasePlayerWeapon_t CP228;
typedef struct CBasePlayerWeapon_t CP90;
typedef struct CBasePlayerWeapon_t CSCOUT;
typedef struct CBasePlayerWeapon_t CSG550;
typedef struct CBasePlayerWeapon_t CSG552;
typedef struct CBasePlayerWeapon_t CSmokeGrenade;
typedef struct CBasePlayerWeapon_t CTMP;
typedef struct CBasePlayerWeapon_t CUMP45;
typedef struct CBasePlayerWeapon_t CUSP;
typedef struct CBasePlayerWeapon_t CFamas;
typedef struct CBasePlayerWeapon_t CGalil;
typedef struct CBasePlayerWeapon_t CXM1014;
typedef struct CCareerTask_t CCareerTask;
typedef struct CCareerTaskManager_t CCareerTaskManager;
