/***
*
*    Copyright (c) 1996-2002, Valve LLC. All rights reserved.
*
*    This product contains software technology licensed from Id
*    Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc.
*    All Rights Reserved.
*
*    Compiling or running this code may violate patents in certain countries.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/

#ifndef CPOINTENTITY__H
#define CPOINTENTITY__H

typedef struct CPointEntity_t CPointEntity;
typedef struct CPointEntity_s
{

	_vt_CPointEntity*		vtable;
	#include "./offsets_cbaseentity.h"
	
} CPointEntity_t;

typedef struct CPathTrack_t CPathTrack;
typedef struct CPathTrack_s 
{

	_vt_CPathTrack*		vtable;
	#include "./offsets_cbaseentity.h"

	float		m_length;
	string_t	m_altName;
	CPathTrack*	m_pnext;
	CPathTrack*	m_pprevious;
	CPathTrack*	m_paltpath;

} CPathTrack_t;

typedef struct CBaseDMStart_t CBaseDMStart;
typedef struct CBaseDMStart_s
{

	_vt_CBaseDMStart*		vtable;
	#include "./offsets_cbaseentity.h"
	
} CBaseDMStart_t;

typedef struct CBlood_t CBlood;
typedef struct CBlood_s
{

	_vt_CBlood*		vtable;
	#include "./offsets_cbaseentity.h"
	
} CBlood_t;

typedef struct CFade_t CFade;
typedef struct CFade_s
{

	_vt_CFade*		vtable;
	#include "./offsets_cbaseentity.h"
	
} CFade_t;

typedef struct CInfoIntermission_t CInfoIntermission;
typedef struct CInfoIntermission_s
{

	_vt_CInfoIntermission*		vtable;
	#include "./offsets_cbaseentity.h"
	
} CInfoIntermission_t;

typedef struct CMessage_t CMessage;
typedef struct CMessage_s
{

	_vt_CMessage*		vtable;
	#include "./offsets_cbaseentity.h"
	
} CMessage_t;

typedef struct CShake_t CShake;
typedef struct CShake_s
{

	_vt_CShake*		vtable;
	#include "./offsets_cbaseentity.h"
	
} CShake_t;

typedef struct CStripWeapons_t CStripWeapons;
typedef struct CStripWeapons_s
{

	_vt_CStripWeapons*		vtable;
	#include "./offsets_cbaseentity.h"
	
} CStripWeapons_t;

typedef struct CTargetCDAudio_t CTargetCDAudio;
typedef struct CTargetCDAudio_s
{

	_vt_CTargetCDAudio*		vtable;
	#include "./offsets_cbaseentity.h"
	
} CTargetCDAudio_t;

typedef struct CTriggerVolume_t CTriggerVolume;
typedef struct CTriggerVolume_s
{

	_vt_CTriggerVolume*		vtable;
	#include "./offsets_cbaseentity.h"
	
} CTriggerVolume_t;

typedef struct CPathCorner_t CPathCorner;
typedef struct CPathCorner_s
{

	_vt_CPathCorner*		vtable;
	#include "./offsets_cbaseentity.h"

	float	m_flWait; // offset 38
} CPathCorner_t;

typedef struct CEnvSound_t CEnvSound;
typedef struct CEnvSound_s
{

	_vt_CEnvSound*		vtable;
	#include "./offsets_cbaseentity.h"
	
	float m_flRadius;		// offset 38 size 1
	float m_flRoomtype;	// offset 39 size 1
} CEnvSound_t;

typedef struct CGlow_t CGlow;
typedef struct CGlow_s
{

	_vt_CGlow*		vtable;
	#include "./offsets_cbaseentity.h"
	
	float		m_lastTime;		// offset 38 size 1
	float		m_maxFrame;	// offset 39 size 1
} CGlow_t;

typedef struct CMapInfo_t CMapInfo;
typedef struct CMapInfo_s
{

	_vt_CMapInfo*		vtable;
	#include "./offsets_cbaseentity.h"

	int		m_ibuying;				// offset 38 size 1
	float		m_flBombRadius;		// offset 39 size 1
} CMapInfo_t;
	
typedef struct CRevertSaved_t CRevertSaved;
typedef struct CRevertSaved_s
{

	_vt_CRevertSaved*		vtable;
	#include "./offsets_cbaseentity.h"
	
	float	m_messageTime;		// offset 38 size 1
	float	m_loadTime;				// offset 39 size 1
} CRevertSaved_t;

typedef struct CEnvGlobal_t CEnvGlobal;
typedef struct CEnvGlobal_s
{

	_vt_CEnvGlobal*		vtable;
	#include "./offsets_cbaseentity.h"
	
	string_t	m_globalstate;		// offset 38 size 1
	int			m_triggermode;	// offset 39 size 1
	int			m_initialstate;	// offset 40 size 1
} CEnvGlobal_t;

typedef struct CMultiSource_t CMultiSource;
typedef struct CMultiSource_s
{

	_vt_CMultiSource*		vtable;
	#include "./offsets_cbaseentity.h"
	
	EHANDLE		m_rgEntities[MS_MAX_TARGETS];	// offset 38 // size 32
	int			m_rgTriggered[MS_MAX_TARGETS];		// offset 102 // size 32
	
	int			m_iTotal;												// offset 134 // size 1
	string_t	m_globalstate;											// offset 135 // size 1
} CMultiSource_t;

#endif

