/***
*
*    Copyright (c) 1996-2002, Valve LLC. All rights reserved.
*
*    This product contains software technology licensed from Id
*    Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc.
*    All Rights Reserved.
*
*    Compiling or running this code may violate patents in certain countries.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/

#ifndef CRULEENTITY__H
#define CRULEENTITY__H

typedef struct CRuleEntity_t CRuleEntity;
typedef struct CRuleEntity_s
{

	_vt_CRuleEntity*		vtable;
	#include "./offsets_cruleentity.h"	

} CRuleEntity_t;

typedef struct CRulePointEntity_t CRulePointEntity;
typedef struct CRulePointEntity_s
{

	_vt_CRulePointEntity*		vtable;
	#include "./offsets_cruleentity.h"	

} CRulePointEntity_t;

typedef struct CGameScore_t CGameScore;
typedef struct CGameScore_s
{

	_vt_CGameScore*		vtable;
	#include "./offsets_cruleentity.h"	

} CGameScore_t;

typedef struct CGameEnd_t CGameEnd;
typedef struct CGameScore_s
{

	_vt_CGameEnd*		vtable;
	#include "./offsets_cruleentity.h"	

} CGameEnd_t;

typedef struct CGameText_t CGameText;
typedef struct CGameText_s
{

	_vt_CGameText*		vtable;
	#include "./offsets_cruleentity.h"	

	hudtextparms_t  	m_textParms;

} CGameText_t;

typedef struct CGameTeamMaster_t CGameTeamMaster;
typedef struct CGameTeamMaster_s
{

	_vt_CGameTeamMaster*		vtable;
	#include "./offsets_cruleentity.h"	

	int			m_teamIndex;
	USE_TYPE		triggerType;

} CGameTeamMaster_t;

typedef struct CGameTeamSet_t CGameTeamSet;
typedef struct CGameTeamSet_s
{

	_vt_CGameTeamSet*		vtable;
	#include "./offsets_cruleentity.h"	

} CGameTeamSet_t;

typedef struct CGamePlayerHurt_t CGamePlayerHurt;
typedef struct CGamePlayerHurt_s
{

	_vt_CGamePlayerHurt*		vtable;
	#include "./offsets_cruleentity.h"	

} CGamePlayerHurt_t;

typedef struct CGameCounter_t CGameCounter;
typedef struct CGameCounter_s
{

	_vt_CGameCounter*		vtable;
	#include "./offsets_cruleentity.h"	

} CGameCounter_t;

typedef struct CGameCounterSet_t CGameCounterSet;
typedef struct CGameCounterSet_s
{

	_vt_CGameCounterSet*		vtable;
	#include "./offsets_cruleentity.h"	

} CGameCounterSet_t;

typedef struct CGamePlayerEquip_t CGamePlayerEquip;
typedef struct CGamePlayerEquip_s
{

	_vt_CGamePlayerEquip*		vtable;
	#include "./offsets_cruleentity.h"	

	string_t		m_weaponNames[32];
	int			m_weaponCount[32];
	
} CGamePlayerEquip_t;

typedef struct CGamePlayerTeam_t CGamePlayerTeam;
typedef struct CGamePlayerTeam_s
{

	_vt_CGamePlayerTeam*		vtable;
	#include "./offsets_cruleentity.h"	

} CGamePlayerTeam_t;

typedef struct CRuleBrushEntity_t CRuleBrushEntity;
typedef struct CRuleBrushEntity_s
{

	_vt_CRuleBrushEntity*		vtable;
	#include "./offsets_cruleentity.h"	
	
} CRuleBrushEntity_t;
	
	
typedef struct CGamePlayerZone_t CGamePlayerZone;
typedef struct CGamePlayerZone_s
{

	_vt_CGamePlayerZone*		vtable;
	#include "./offsets_cruleentity.h"	

	string_t		m_iszInTarget;
	string_t		m_iszOutTarget;
	string_t		m_iszInCount;
	string_t		m_iszOutCount;
	
} CGamePlayerZone_t;

#endif
