/***
*
*    Copyright (c) 1996-2002, Valve LLC. All rights reserved.
*
*    This product contains software technology licensed from Id
*    Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc.
*    All Rights Reserved.
*
*    Compiling or running this code may violate patents in certain countries.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/

#ifndef _GOLDSRC_CS_SDK_CS_CLASSES_EXTRA_H_
#define _GOLDSRC_CS_SDK_CS_CLASSES_EXTRA_H_

typedef struct CVoiceGameMgr_t CVoiceGameMgr;
typedef struct CVoiceGameMgr_s
{
#ifndef __linux__
    void*		vtbl;
    int			_dummy;
#endif
    int			m_msgPlayerVoiceMask;
    int			m_msgRequestState;

    void*		m_pHelper;
    int			m_nMaxPlayers;
    double		m_UpdateInterval;
#ifdef __linux__
    void*		vtbl;
#endif

} CVoiceGameMgr_t;

typedef struct IVoiceGameMgrHelper_t IVoiceGameMgrHelper;
typedef struct IVoiceGameMgrHelper_s
{
	_vt_IVoiceGameMgrHelper*		vtbl;
	
} IVoiceGameMgrHelper_t;

typedef struct CCStrikeGameMgrHelper_t CCStrikeGameMgrHelper;
typedef struct CCStrikeGameMgrHelper_s
{
	_vt_CCStrikeGameMgrHelper*		vtbl;
	
} CCStrikeGameMgrHelper_t;
	
typedef struct CHalfLifeMultiplay_t CHalfLifeMultiplay;
typedef struct CHalfLifeMultiplay_s
{
//#ifndef __linux__
	_vt_CHalfLifeMultiplay*		vtbl;					// windows 0
//#endif
	BOOL		m_fFreezePeriod;			// 0 // windows +1
	BOOL		m_fBombDropped;				// 1 // windows +1

//#ifdef __linux__
//	_vt_CHalfLifeMultiplay*		vtbl;					// linux 2
//#else
//	int		_dummy_3_win32;
//#endif

	CVoiceGameMgr_t 	m_sVoiceGameMgr;			// 3 // windows +1 // windows 8* 4bytes, linux 7* 4bytes
	
	float		m_flRestartRoundTime;			// 10 // windows +2 untill the end

	int		_dummy_11;

	int		m_fRoundCount;				// 12
	int		m_iRoundTime;				// 13 // secs !!!
	int		m_iRoundTimeSecs;			// 14
	int		m_iFreezeTime;				// 15

	float		m_flEndOfFreezeTime;			// 16

	int		m_iAccountTerrorist;			// 17
	int		m_iAccountCT;				// 18

	int		m_iNumTerrorist;			// 19
	int		m_iNumCT;				// 20

	int		m_iNumSpawnableTerrorist;		// 21
	int		m_iNumSpawnableCT;			// 22

	int		m_iTeSpawnsNum;				// 23
	int		m_iCtSpawnsNum;				// 24

	int		m_iHostagesRescued;			// 25
	int		m_iHostagesTouched;			// 26
	int		m_iRoundWinStatus;			// 27
	int16		m_iTerroristsScore;			// 28	// 56u
	int16		m_iCTsScore;				// 28	// 57u

	byte		m_bTargetBombed;			// 29
	byte		m_bBombDefused;				// 29
	byte		m_bMapHasBombTarget;			// 29
	byte		m_bMapHasBombZone;			// 29

	byte		m_bMapHasBuyZone;			// 30
	byte		m_bMapHasRescueZone;			// 30
	byte		m_bMapHasEscapeZone;			// 30
	byte		_dummy_30_4;						// 30

	int		m_iMapHasVIPSafetyZone;			// 31 // == 2 no zone found

	int		m_fMapHasCamera;			// 32 // initialized to 2=Not Set, 1=Has Cam, 0=No Cam
	int		m_iC4Timer;				// 33
	int		m_iLastBomber;				// 34 // CHalfLifeMultiplay::GiveC4
	int		m_iLoserBonus;				// 35
	int		m_iCtWinningStreak;			// 36
	int		m_iTeWinningStreak;			// 37
	float		m_fMaxIdlePeriod;			// 38
	int		m_iLimitTeams;				// 39
	byte		m_bSpawnsCounted;			// 40 // Set to 0 in GameDllInit and checked in Think, if false, spawns are counted in order to fill m_iTeSpawnsNum and m_iCtSpawnsNum (see TeamFull)
	byte		m_bRoundTerminating;			// 40
	byte		m_bCompleteReset;			// 40
	byte		_dummy_40_3;						// 40

	int		m_flRequiredEscapeRatio;		// 41
	int		m_iNumEscapers;				// 42
	int		m_iHaveEscaped;				// 43 // count

	byte		m_bCtShopDisabled;			// 44
	byte		m_bTeShopDisabled;			// 44
	byte		_dummy_44_[2];

	float		m_flC4RadiusDamage;			// 45 // ??? /// initialized to 500.0
	int		m_iConsecutiveVIP;			// 46
	int		m_iWeaponsNum;				// 47
	int		m_iGrenadesNum;				// 48
	int		m_iArmorsNum;				// 49
	int		m_iUnBalancedRounds;			// 50
	int		m_iNumEscapeRounds;			// 51
	int		m_iMapsVotesNumbers[100];		// 52
	int		m_iLastPick;				// 152

	int		_dummy_153;

	int		m_iMaxRounds;				// 154
	int		m_iTotalRoundsPlayed;			// 155
	int		m_iWinLimit;				// 156
	BOOL		m_fAllowSpectators;			// 157
	float		m_flForceCamera;			// 158
	float		m_flForceChaseCamera;			// 159
	float		m_flFadeToBlack;			// 160
	CBasePlayer*	m_pVIP;					// 161
	CBaseEntity*	m_iVipQueueCount[5];			// 162
	float		m_flIntermissionEndTime;		// 167
	float		m_flIntermissionStartTime;		// 168
	BOOL		m_fEndIntermissionButtonHit;		// 169
	float		m_flNextThink;				// 170
	byte		m_bMatchStarted;			// 171
	byte		m_bIsCareer;				// 171
	byte		_dummy_171_3[2];

	float		_dummy_172;
	int		m_iCareerMatchLimit;				// offset 173
	int 		m_iCareerWinDifference;			// 174

	float		m_flCareerNextThing;			// 175 // initialized to 0 // CHalfLifeMultiplay::Think() // checked in CHalfLifeMultiplay::QueueCareerRoundEndMenu and set to gametime + 3.0, return if < gametime
	byte		m_bShouldSkipSpawn;			// 176
	byte		_dummy_13514[3];

} CHalfLifeMultiplay_t;

typedef struct CHalfLifeMultiplay_t CGameRules;
typedef struct CHalfLifeMultiplay_t CGameRules_t;

#endif  // _GOLDSRC_CS_SDK_CS_CLASSES_EXTRA_H_
