// IDA HELPER TOOL
//
//
// - Set prototype functions based no mangled symbols
//		custom types should be exist on IDA before running this script
//
//

#include <idc.idc>

#define VERBOSE 1

#define VAC 1

static main(void)
{
	ProcOffsets();
}

static ProcOffsets(void)
{
	auto start, end, ea, xea;
	auto name, i;
	auto isize;

	auto ent, entb, plt, savedata, pointer, instance;

	start = SegStart(GetSeg(".data"));
	end = SegEnd(start);
	ea = start;
	while (ea >= start && ea <= end)
	{
		name = Name(ea);
		if(strstr(name, "SaveData") == (strlen(name) - 8) && strstr(name, "_m_") > 0)
		{
			isize = ItemSize(ea) / 16;
			Message("Data dump: %s - %i - 0x%x\n", name, isize, ea);
			SetType(ea, "TYPEDESCRIPTION;");
			MakeArray(ea, isize);
			DumpOffsets(ea);
		}
		ea = NextAddr(ea);
	}
}

static DumpOffsets(ea)
{
	auto i, isize, type, offset, osize, tmp;
	isize = ItemSize(ea)/16;
	
	for(i = 0; i < isize; i++)
	{
		tmp = Dword(ea + (16 * i));

		if(tmp == 0)
			type = "float";

		if(tmp == 1)
			type = "char *";

		if(tmp == 2)
			type = "int";

		if(tmp == 3)
			type = "CBaseEntity*";

		if(tmp == 4)
			type = "_EHANDLE*";

		if(tmp == 5)
			type = "entvars_t*";

		if(tmp == 6)
			type = "edict_t*";

		if(tmp == 7)
			type = "Vector";

		if(tmp == 8)
			type = "Vector";

		if(tmp == 9)
			type = "void*";

		if(tmp == 10)
			type = "int";

		if(tmp == 11)
			type = "void*";

		if(tmp == 12)
			type = "bool";

		if(tmp == 13)
			type = "int16";

		if(tmp == 14)
			type = "byte";

		if(tmp == 15)
			type = "float";

		if(tmp == 16)
			type = "char*";

		if(tmp == 17)
			type = "char*";

		if(tmp == 18)
			type = "int";


		osize = Word(ea + (16 * i) + 12);
		offset = GetString(Dword(ea + (16 * i) + 4), -1, 0);
		if(osize > 1)
			offset = sprintf("%s[%i]", offset, osize);
		Message("\t%s\t%s;\t\t// offset %i (%i) - size %i\n", type, offset, Dword(ea + (16 * i) + 8)/4, Dword(ea + (16 * i) + 8), osize);
	}
	Message("\n");
}