/***
*
*    Copyright (c) 1996-2002, Valve LLC. All rights reserved.
*
*    This product contains software technology licensed from Id
*    Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc.
*    All Rights Reserved.
*
*    Compiling or running this code may violate patents in certain countries.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/

typedef unsigned char BYTE;
typedef enum { USE_OFF = 0, USE_ON = 1, USE_SET = 2, USE_TOGGLE = 3 } USE_TYPE;

typedef enum {
	NO_SVC = 0, SVC_NOP, SVC_DISCONNECT, SVC_EVENT, SVC_VERSION, SVC_SETVIEW, SVC_SOUND, SVC_TIME, SVC_PRINT,
	SVC_STUFFTEXT, SVC_SETANGLE, SVC_SERVERINFO, SVC_LIGHTSTYLE, SVC_UPDATEUSERINFO, SVC_DELTADESCRIPTION, SVC_CLIENTDATA, SVC_STOPSOUND,
	SVC_PINGS, SVC_PARTICLE, SVC_DAMAGE, SVC_SPAWNSTATIC, SVC_EVENT_RELIABLE, SVC_SPAWNBASELINE, SVC_TEMPENTITY, SVC_SETPAUSE,
	SVC_SIGNONNUM, SVC_CENTERPRINT, SVC_KILLEDMONSTER, SVC_FOUNDSECRET, SVC_SPAWNSTATICSOUND, SVC_INTERMISSION, SVC_FINALE, SVC_CDTRACK,
	SVC_RESTORE, SVC_CUTSCENE, SVC_WEAPONANIM, SVC_DECALNAME, SVC_ROOMTYPE, SVC_ADDANGLE, SVC_NEWUSERMSG, SVC_PACKETENTITIES,
	SVC_DELTAPACKETENTITIES, SVC_CHOKE, SVC_RESOURCELIST, SVC_NEWMOVEVARS, SVC_RESOURCEREQUEST, SVC_CUSTOMIZATION, SVC_CROSSHAIRANGLE, SVC_SOUNDFADE,
	SVC_FILETXFERFAILED, SVC_HLTV, SVC_DIRECTOR, SVC_VOICEINIT, SVC_VOICEDATA, SVC_SENDEXTRAINFO, SVC_TIMESCALE
} SVC_LIST;

typedef enum { MSG_BROADCAST = 0, MSG_ONE, MSG_ALL, MSG_INIT, MSG_PVS, MSG_PAS, MSG_PVS_R, MSG_PAS_R, MSG_ONE_UNRELIABLE, MSG_SPEC } MSG_DEST;

typedef enum
{

        MONSTERSTATE_NONE = 0,
        MONSTERSTATE_IDLE,
        MONSTERSTATE_COMBAT,
        MONSTERSTATE_ALERT,
        MONSTERSTATE_HUNT,
        MONSTERSTATE_PRONE,
        MONSTERSTATE_SCRIPT,
        MONSTERSTATE_PLAYDEAD,
        MONSTERSTATE_DEAD

} MONSTERSTATE;

typedef enum
{
        TS_AT_TOP,
        TS_AT_BOTTOM,
        TS_GOING_UP,
        TS_GOING_DOWN
} TOGGLE_STATE;

typedef enum {
        ACT_RESET = 0,          // Set m_Activity to this invalid value to force a reset to m_IdealActivity
        ACT_IDLE = 1,
        ACT_GUARD,
        ACT_WALK,
        ACT_RUN,
        ACT_FLY,                                // Fly (and flap if appropriate)
        ACT_SWIM,
        ACT_HOP,                                // vertical jump
        ACT_LEAP,                               // long forward jump
        ACT_FALL,
        ACT_LAND,
        ACT_STRAFE_LEFT,
        ACT_STRAFE_RIGHT,
        ACT_ROLL_LEFT,                  // tuck and roll, left
        ACT_ROLL_RIGHT,                 // tuck and roll, right
        ACT_TURN_LEFT,                  // turn quickly left (stationary)
        ACT_TURN_RIGHT,                 // turn quickly right (stationary)
        ACT_CROUCH,                             // the act of crouching down from a standing position
        ACT_CROUCHIDLE,                 // holding body in crouched position (loops)
        ACT_STAND,                              // the act of standing from a crouched position
        ACT_USE,
        ACT_SIGNAL1,
        ACT_SIGNAL2,
        ACT_SIGNAL3,
        ACT_TWITCH,
        ACT_COWER,
        ACT_SMALL_FLINCH,
        ACT_BIG_FLINCH,
        ACT_RANGE_ATTACK1,
        ACT_RANGE_ATTACK2,
        ACT_MELEE_ATTACK1,
        ACT_MELEE_ATTACK2,
        ACT_RELOAD,
        ACT_ARM,                                // pull out gun, for instance
        ACT_DISARM,                             // reholster gun
        ACT_EAT,                                // monster chowing on a large food item (loop)
        ACT_DIESIMPLE,
        ACT_DIEBACKWARD,
        ACT_DIEFORWARD,
        ACT_DIEVIOLENT,
        ACT_BARNACLE_HIT,               // barnacle tongue hits a monster
        ACT_BARNACLE_PULL,              // barnacle is lifting the monster ( loop )
        ACT_BARNACLE_CHOMP,             // barnacle latches on to the monster
        ACT_BARNACLE_CHEW,              // barnacle is holding the monster in its mouth ( loop )
        ACT_SLEEP,
        ACT_INSPECT_FLOOR,              // for active idles, look at something on or near the floor
        ACT_INSPECT_WALL,               // for active idles, look at something directly ahead of you ( doesn't HAVE to be a wall or on a wall )
        ACT_IDLE_ANGRY,                 // alternate idle animation in which the monster is clearly agitated. (loop)
        ACT_WALK_HURT,                  // limp  (loop)
        ACT_RUN_HURT,                   // limp  (loop)
        ACT_HOVER,                              // Idle while in flight
        ACT_GLIDE,                              // Fly (don't flap)
        ACT_FLY_LEFT,                   // Turn left in flight
        ACT_FLY_RIGHT,                  // Turn right in flight
        ACT_DETECT_SCENT,               // this means the monster smells a scent carried by the air
        ACT_SNIFF,                              // this is the act of actually sniffing an item in front of the monster
        ACT_BITE,                               // some large monsters can eat small things in one bite. This plays one time, EAT loops.
        ACT_THREAT_DISPLAY,             // without attacking, monster demonstrates that it is angry. (Yell, stick out chest, etc )
        ACT_FEAR_DISPLAY,               // monster just saw something that it is afraid of
        ACT_EXCITED,                    // for some reason, monster is excited. Sees something he really likes to eat, or whatever.
        ACT_SPECIAL_ATTACK1,    // very monster specific special attacks.
        ACT_SPECIAL_ATTACK2,
        ACT_COMBAT_IDLE,                // agitated idle.
        ACT_WALK_SCARED,
        ACT_RUN_SCARED,
        ACT_VICTORY_DANCE,              // killed a player, do a victory dance.
        ACT_DIE_HEADSHOT,               // die, hit in head.
        ACT_DIE_CHESTSHOT,              // die, hit in chest
        ACT_DIE_GUTSHOT,                // die, hit in gut
        ACT_DIE_BACKSHOT,               // die, hit in back
        ACT_FLINCH_HEAD,
        ACT_FLINCH_CHEST,
        ACT_FLINCH_STOMACH,
        ACT_FLINCH_LEFTARM,
        ACT_FLINCH_RIGHTARM,
        ACT_FLINCH_LEFTLEG,
        ACT_FLINCH_RIGHTLEG,
} Activity;

typedef enum {
	FL_FLY = (1<<0),
	FL_SWIM = (1<<1),
	FL_CONVEYOR = (1<<2),
	FL_CLIENT = (1<<3),
	FL_INWATER = (1<<4),
	FL_MONSTER = (1<<5),
	FL_GODMODE = (1<<6),
	FL_NOTARGET = (1<<7),
	FL_SKIPLOCALHOST = (1<<8),
	FL_ONGROUND = (1<<9),
	FL_PARTIALGROUND = (1<<10),
	FL_WATERJUMP = (1<<11),
	FL_FROZEN = (1<<12),
	FL_FAKECLIENT = (1<<13),
	FL_DUCKING = (1<<14),
	FL_FLOAT = (1<<15),
	FL_GRAPHED = (1<<16),
	FL_IMMUNE_WATER = (1<<17),
	FL_IMMUNE_SLIME = (1<<18),
	FL_IMMUNE_LAVA = (1<<19),
	FL_PROXY = (1<<20),
	FL_ALWAYSTHINK = (1<<21),
	FL_BASEVELOCITY = (1<<22),
	FL_MONSTERCLIP = (1<<23),
	FL_ONTRAIN = (1<<24),
	FL_WORLDBRUSH = (1<<25),
	FL_SPECTATOR = (1<<26),
	FL_CUSTOMENTITY = (1<<29),
	FL_KILLME = (1<<30),
	FL_DORMANT = (1<<31)
} PEV_FLAGS;
