// IDA HELPER TOOL
//
//
// - Set prototype functions based no mangled symbols
//		custom types should be exist on IDA before running this script
//
//

#include <idc.idc>

#define VERBOSE 1

#define VAC 1

static main(void)
{
	auto fil_nam;

	SetCharPrm(INF_SIZEOF_BOOL, 1);
	fil_nam = AskFile(0,"*.*","Choose a symbols file to parse:");
	if (fil_nam == "") return;
	FixTypes(fil_nam,"","");
}

static FixTypes(H_File_Name,enum_name,enum_pattern)
{
	auto hh, in_str, errors, sucesss;
	if ((hh=fopen(H_File_Name,"r")) == 0)
	{
		Warning("Couldn't open file '%s'!",H_File_Name);
		return -1;
	}

	errors = 0;
	sucesss = 0;
	while ((in_str=readstr(hh)) != -1)
	{
		auto symbol, type, cosa;
		auto index, index2, oldtype, final;
		
		index = strstr(in_str, "|");
		index2 = strstr(substr(in_str, index + 1, -1), "|");
		symbol = substr(in_str, 0, index);
		cosa = substr(in_str, index + 1, index + index2 + 1);
		type = substr(in_str, index + index2 + 2, strlen(in_str) - 1);
		
//		if(strstr(in_str, "Killed__11CBasePlayerP9entvars_s") < 0)
//			continue;
		
		if(strstr(cosa, "o") != -1)
		{
			if(LocByName(symbol))
			{
				if(LocByName(symbol) != -1)
				{
//					Message("Ok: %s %s\n", symbol, type);
					SetType(LocByName(symbol), type + ";");
					sucesss++;
				}
				SetType(LocByName(symbol), type + ";");

				if(LocByName("." + symbol) != -1)
				{
//					Message("Ok: %s %s\n", "." + symbol, type);
					SetType(LocByName("." + symbol), type + ";");
					sucesss++;
				}
				sucesss++;
			}
			else
			{
				errors++;
			}
		}
		else if(strstr(cosa, "f") != -1)
		{
			if(strlen(GetFunctionName(LocByName(symbol))) > 0)
			{
				oldtype = GetType(LocByName(symbol));

				if(strlen(oldtype) <= 0)
					oldtype = Demangle(GetFunctionName(LocByName(symbol)), 0);

				final = type + " " + symbol + " "+ substr(oldtype, strstr(oldtype, "("), -1) + ";";
				if(strlen(final) > 1 && ParseTypes(final, 2) == 0)
				{
//					Message("Ok: %s\n", final);
					SetType(LocByName(symbol), final);
					sucesss++;
				}
				else
				{
					errors++;
					Message("Error: %s | %s\n", final, oldtype);
				}
			}

			if(strlen(GetFunctionName(LocByName("." + symbol))) > 0)
			{
				oldtype = GetType(LocByName("." + symbol));
				if(strlen(oldtype <= 0))
					oldtype = Demangle(GetFunctionName(LocByName("." + symbol)), 0);
		
				final = type + " _" + symbol + " "+ substr(oldtype, strstr(oldtype, "("), -1) + ";";

				if(strlen(final) > 1 && ParseTypes(final, 2) == 0)
				{
//					Message("Ok: %s\n", final);
					SetType(LocByName("." + symbol), final);
					sucesss++;
				}
				else
				{
					errors++;
					Message("Error 2: %s | %s\n", final, oldtype);
				}
			}
		}
	}
	Message("Results: sucesss:%i errors:%i\n", sucesss, errors);

}

static IsLocalType(name)
{
	auto i, max;
	
	if(strlen(name) < 2)
		return 0;

	max = GetMaxLocalType();
	for(i = 0; i < max; i++)
	{
		if(name == GetLocalTypeName(i))
			return 1;
	}
	return 0;
}
